arch=`dpkg --print-architecture`
version=`cat ../docs/VERSION`

mv benchpress.list benchpress.list.moved
cat benchpress.list.moved | grep -v "%version" >> benchpress.list
echo "%version $version" >> benchpress.list
rm benchpress.list.moved

# Make sure EPM is installed
if [ ! -e /usr/bin/epm ]
	then
		echo 'EPM is not installed.  Use "sudo apt-get install epm" to install it'
		exit 1
fi

# If there is no executable, try to build it...
if [ ! -e ../bin/benchpress ]
	then
		echo "Benchpress is not built.  Attempting to build now..."
		cd ../src
		make clean > /dev/null 2>&1
		make > /dev/null 2>&1
		cd ../bundler
fi

# ...if there is still no executable, then abort
if [ ! -e ../bin/benchpress ]
	then
		echo "Fatal error building Benchpress.  Aborting..."
		echo
		exit 1
fi

# Package it up
epm -a $arch -f deb benchpress > /dev/null 2>&1

# Check if there is a new package present
if [ ! -d linux-2.6-$arch ]
	then
		echo "Fatal error bundling Benchpress."
		exit 1
fi

mv linux-2.6-$arch/*.deb ../.. > /dev/null 2>&1
rm -rf linux-2.6-$arch

echo "Package successfully built!"

exit 0
