#include "bp-spec.h"

void get_spec()
{
	get_spec_cpu();
}

void get_spec_cpu()
{
	GtkWidget *editbox;
	int cpus = count_cpus();
	char model_name[200];
	char kernel_name[200];
	char vendor_id[200];
	int cpu_speed;
	int cpu_cores;
	int cache_size;
	long mem_size;
	long mem_free;
	char text[1000];
	
	getStrValue("model name", "/proc/cpuinfo", model_name);
	getStr("/proc/version_signature", kernel_name);
	cpu_speed = getIntValue("cpu MHz", "/proc/cpuinfo");
	cache_size = getIntValue("cache size", "/proc/cpuinfo");
	cpu_cores = getIntValue("cpu cores", "/proc/cpuinfo");
	mem_size = getIntValue("MemTotal", "/proc/meminfo");
	mem_free = getIntValue("MemFree", "/proc/meminfo");
	getStrValue("vendor_id", "/proc/cpuinfo", vendor_id);
	float mem_free_percent = (float)mem_free*100/(float)mem_size;
	mem_size = mem_size / 1024;
	
	if (cpu_cores!=-1 && cpu_cores!=cpus)
		sprintf(text, "%d (%d physical)", cpus, cpu_cores);
	else
		sprintf(text, "%d", cpus);
	editbox = glade_xml_get_widget(xml_results,"e_cores");
	gtk_entry_set_text(GTK_ENTRY(editbox), text);
	
	editbox = glade_xml_get_widget(xml_results,"l_cpu");
	gtk_label_set_label(GTK_LABEL(editbox), model_name);
	
	sprintf(text,"%d MHz", cpu_speed);
	editbox = glade_xml_get_widget(xml_results,"e_speed");
	gtk_entry_set_text(GTK_ENTRY(editbox), text);
	
	sprintf(text, "%d KB", cache_size);
	editbox = glade_xml_get_widget(xml_results,"e_cache");
	gtk_entry_set_text(GTK_ENTRY(editbox), text);

	sprintf(text, "%d MB", mem_size);
	editbox = glade_xml_get_widget(xml_results,"e_ram");
	gtk_entry_set_text(GTK_ENTRY(editbox), text);

	sprintf(text, "%.0f%%" , mem_free_percent);	
	editbox = glade_xml_get_widget(xml_results,"e_free");
	gtk_entry_set_text(GTK_ENTRY(editbox), text);

	if (strncmp(vendor_id, "GenuineIntel", 12) == 0)
		sprintf(text, "gfx/intel.png");
	if (strncmp(vendor_id, "AuthenticAMD", 12) == 0)
		sprintf(text, "gfx/amd.png");
	editbox = glade_xml_get_widget(xml_results,"img_cputype");
	gtk_image_set_from_file(GTK_IMAGE(editbox), text);

}

int count_cpus()
{	
	char teststr[200];
	FILE *Fp;
	Fp = fopen("/proc/cpuinfo", "r");
	int proccnt=0;
	while (!feof(Fp))
	{
		fscanf(Fp, "%s", &teststr);
		if (strcmp(teststr, "vendor_id") == 0)				// Don't count 'processor' string- sometimes occurs elsewhere
			proccnt++;
	}
	
	fclose(Fp);
	return proccnt;
}

int getIntValue(char *key, char *proc_name)
{
	char teststr[200];
	char buffer[200];
	FILE *Fp;
	Fp = fopen(proc_name, "r");
	strcpy(buffer, "-1 ");									// Default value is -1
	while (!feof(Fp))
	{
		fgets(teststr,200,Fp);
		if (strncmp(teststr, key, strlen(key)) == 0)
		{
			char *p_pch = strchr(teststr, ':')+2;
			strcpy(buffer, p_pch);
		}
	}
	buffer[strlen(buffer)-1]=0;
	int val = atoi(buffer);
	fclose(Fp);
	return val;
}

void getStr(char *proc_name, char *buffer)
{
	char teststr[200];
	FILE *Fp;
	Fp = fopen(proc_name, "r");
	fgets(teststr,200,Fp);
	strcpy(buffer, teststr);
	fclose(Fp);
}


void getStrValue(char *key, char *proc_name, char *buffer)
{
	char teststr[200];
	FILE *Fp;
	Fp = fopen(proc_name, "r");
	while (!feof(Fp))
	{
		fgets(teststr,200,Fp);
		if (strncmp(teststr, key, strlen(key)) == 0)
		{
			char *p_pch = strchr(teststr, ':')+2;
			strcpy(buffer, p_pch);
		}
	}
	buffer[strlen(buffer)-1]=0;
	fclose(Fp);
}
